/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: TestHelperNoTouch.java,v a5bfc866e5f8 2010/08/14 13:59:48 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.impl;

import android.app.Instrumentation;
import android.test.ActivityInstrumentationTestCase2;
import android.view.KeyEvent;
import android.widget.ImageButton;
import android.widget.ListView;
import com.jayway.android.robotium.solo.Solo;
import it.tidalwave.bluebill.mobile.android.TestHelper;
import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class TestHelperNoTouch extends TestHelper
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public TestHelperNoTouch (final @Nonnull ActivityInstrumentationTestCase2 instrumentationTestCase,
                              final @Nonnull Solo solo)
      {
        super(instrumentationTestCase, solo);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public void clickOnImageButtonById (final int id)
      {
        final ImageButton button = (ImageButton)solo.getCurrentActivity().findViewById(id);

        if (button == null)
          {
            throw new AssertionError("Cannot find button #" + id + " on " + solo.getCurrentActivity());
          }

        solo.sleep(generalDelay);
        requestFocus(button);
        instrumentationTestCase.sendKeys(KeyEvent.KEYCODE_DPAD_CENTER);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public void clickOnListView (final @Nonnull ListView listView, final @Nonnegative int index)
      {
        if (true) // scroll down
          {
            requestFocus(listView);
            final Instrumentation instrumentation = instrumentationTestCase.getInstrumentation();

            for (int i = 0; i < index; i++)
              {
                instrumentationTestCase.sendKeys(KeyEvent.KEYCODE_DPAD_DOWN);
                instrumentation.waitForIdleSync();
                solo.sleep(generalDelay);
              }

            press(KeyEvent.KEYCODE_DPAD_CENTER);
          }

        else // immediate click - doesn't work, doesn't put the focus in the proper place
          {
            requestFocus(listView);
            requestFocus(listView.getChildAt(index));
            press(KeyEvent.KEYCODE_DPAD_CENTER);
          }
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public void confirmDialog()
      {
        // FIXME: assert that there's a dialog
        // FIXME: find the Ok button first!
        solo.sleep(500);
        press(KeyEvent.KEYCODE_DPAD_CENTER);
      }
  }
