/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: TaxonomyBrowserActivityTestHelper.java,v 07b3273cc613 2010/08/06 19:59:21 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.taxonomy.browser;

import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import it.tidalwave.bluebill.mobile.android.R;
import it.tidalwave.bluebill.mobile.android.ActivityTestHelper;
import android.test.ActivityInstrumentationTestCase2;
import android.widget.ListView;
import android.widget.TextView;
import com.jayway.android.robotium.solo.Solo;
import static android.test.ActivityInstrumentationTestCase2.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class TaxonomyBrowserActivityTestHelper extends ActivityTestHelper
  {
    public TaxonomyBrowserActivityTestHelper (final @Nonnull ActivityInstrumentationTestCase2 instrumentationTestCase,
                                              final @Nonnull Solo solo)
      {
        super(instrumentationTestCase, solo);
      }

    public void waitForActivity()
      throws InterruptedException
      {
        testHelper.waitForActivity(TaxonomyBrowserActivity.class);
      }

    public void waitForTaxaListNotEmpty()
      throws InterruptedException
      {
        testHelper.waitForListNotEmpty(android.R.id.list);
      }

    public void filterKey (final int c)
      {
        testHelper.sendFilterKeyToListView(getListView(), c);
      }

    public void filterKeys (final @Nonnull String chars)
      {
        testHelper.sendFilterKeyToListView(getListView(), chars);
      }

    public void clickOnKeyboardButton()
      {
        testHelper.clickOnImageButtonById(R.id.btFilter);
      }

    public void clickOnTaxon (final @Nonnegative int index)
      {
        testHelper.clickOnListView(getListView(), index);
      }

    public void assertTaxaCount (final @Nonnegative int count)
      {
        assertEquals(count, getListView().getAdapter().getCount());
      }

    public void assertHeaderText (final @Nonnull String text)
      {
        final TextView textView = (TextView)solo.getCurrentActivity().findViewById(R.id.tvFooter);
        assertEquals(text, textView.getText().toString());
      }

    @Nonnull
    private ListView getListView()
      {
        return (ListView)solo.getCurrentActivity().findViewById(android.R.id.list);
      }
  }
